/***
 * Excerpted from "The ThoughtWorks Anthology 2",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/twa2 for more book information.
***/
import org.springframework.core.type.classreading.MetadataReader;
import org.springframework.core.type.classreading.MetadataReaderFactory;
import org.springframework.core.type.filter.AnnotationTypeFilter;
import org.springframework.core.type.filter.TypeFilter;

import java.io.IOException;
import java.util.Map;

public class FeatureIncludeFilter implements TypeFilter {

    private final TypeFilter fooFilter = new AnnotationTypeFilter(Foo.class, true);

    public boolean match(MetadataReader metadataReader, 
                         MetadataReaderFactory metadataReaderFactory)
        throws IOException {

        if (fooFilter.match(metadataReader, metadataReaderFactory)) {
            boolean value = getAnnotationValue(metadataReader, Foo.class);

            if (FeatureToggles.isFooEnabled()) {
                return value;
            } else {
                return !value;
            }
        }
        return false;
    }

    private boolean getAnnotationValue(MetadataReader metadataReader, 
                                     Class annotationClass) {
        return (Boolean) metadataReader.
            getAnnotationMetadata().
            getAnnotationAttributes(annotationClass.getName()).
            get("value");
    }
}
